import type { MessageHandler } from 'element-plus';
import type { RouteLocationNormalizedLoaded } from 'vue-router';
import type { DefineComponent, ComponentInternalInstance, Ref, ComputedRef, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
declare const _sfc_main: DefineComponent<{
    url: {
        type: StringConstructor;
        required: true;
    };
    source: {
        type: null;
        required: true;
    };
    rowKey: {
        type: StringConstructor;
        required: false;
    };
    rowKeys: {
        type: ArrayConstructor;
        required: false;
    };
    keyName: {
        type: StringConstructor;
        required: false;
    };
    AddInitID: {
        type: ArrayConstructor;
        required: false;
    };
    watchData: {
        type: ArrayConstructor;
        required: false;
    };
    hooks: {
        type: null;
        required: false;
    };
    wrapperStyle: {
        type: ObjectConstructor;
        required: false;
    };
    tableHeight: {
        type: NumberConstructor;
        required: false;
    };
    tableAttributes: {
        type: ObjectConstructor;
        required: false;
    };
    editFooterButton: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    queryAfterMount: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    permission: {
        type: ArrayConstructor;
        required: false;
        default: () => any;
    };
    IssearchForm: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    openIndex: {
        type: BooleanConstructor;
        required: false;
    };
    openMultipleSelection: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    expand: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    expandColumn: {
        type: NumberConstructor;
        required: false;
        default: () => any;
    };
    dialogWidth: {
        type: NumberConstructor;
        required: false;
        default: () => any;
    };
    fullscreen: {
        type: BooleanConstructor;
        required: false;
    };
    closeOnPressEscape: {
        type: BooleanConstructor;
        required: false;
    };
    destroyOnClosModal: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    PaginationLayout: {
        type: StringConstructor;
        required: false;
        default: () => any;
    };
    hideOnSinglePage: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
}, {
    props: {
        url: string;
        source: SourceOptType;
        rowKey?: string | undefined;
        rowKeys?: string[] | undefined;
        keyName?: string | undefined;
        AddInitID?: string[] | undefined;
        watchData?: watchDataType[] | undefined;
        hooks?: HooksConfigType | undefined;
        wrapperStyle?: object | undefined;
        tableHeight?: number | undefined;
        tableAttributes?: object | undefined;
        editFooterButton: boolean;
        queryAfterMount: boolean;
        permission: string[];
        IssearchForm: boolean;
        openIndex?: boolean | undefined;
        openMultipleSelection: boolean;
        expand: boolean;
        expandColumn: number;
        dialogWidth: number;
        fullscreen?: boolean | undefined;
        closeOnPressEscape?: boolean | undefined;
        destroyOnClosModal: boolean;
        PaginationLayout: string;
        hideOnSinglePage: boolean;
    };
    emit: (event: "update:modelValue" | "cell-click" | "row-contextmenu", ...args: any[]) => void;
    internalInstance: ComponentInternalInstance | null;
    route: RouteLocationNormalizedLoaded;
    searchFormRef: Ref<any>;
    buttonAreaRef: Ref<any>;
    tableRef: Ref<any>;
    editFormRef: Ref<any>;
    Mode: Ref<string>;
    DialogVisible: Ref<boolean>;
    tableLoading: Ref<boolean>;
    submitLoading: Ref<boolean>;
    DialogVisibleFooterButton: Ref<boolean>;
    CrudParams: any;
    hookHandler: (hookName: string, data: {
        CrudState: any;
        Data: any;
    }) => boolean;
    CRUDRequest: any;
    ElementArrs: Ref<{
        filter: columnsType;
        editor: columnsType;
        column: columnsType;
    }>;
    tableColumn: Ref<any>;
    tableData: Ref<any>;
    originalData: Ref<any>;
    initSearchModel: Ref<any>;
    initEditModel: Ref<any>;
    searchModel: any;
    searchFormValue: any;
    editModel: any;
    editFormValue: any;
    multipleSelection: Ref<never[]>;
    uploadFiles: Ref<never[]>;
    Pagination: {
        current: any;
        pageSize: any;
        total: any;
    };
    clientHeight: Ref<number>;
    OpenSearchFormtableMaxHeight: Ref<number>;
    CloseSearchFormtableMaxHeight: Ref<number>;
    EditFormMaxHeight: Ref<number>;
    SearchForm: ComputedRef<columnsType>;
    EditorForm: ComputedRef<columnsType>;
    WrapperStyle: ComputedRef<{}>;
    indexMethod: ComputedRef<number>;
    TableHeight: ComputedRef<number>;
    EditFormHeight: ComputedRef<number>;
    KeyHandling: (data: any) => any;
    IsRange: (item: columnsItemType) => any;
    componentState: (column: columnsItemType, mode: 'visible' | 'disabled') => boolean | undefined;
    cellClick: (row: any, column: any, cell: any, event: any) => void;
    cellDblclick: (row: any, column: any, cell: any, event: any) => void;
    rowContextmenu: (row: any, column: any, event: any) => void;
    handleSelectionChange: (value: any) => void;
    formComponentProps: (props: any) => any;
    tableComponentProps: (tableColumn: any, scope: any) => any;
    componentVisible: (visible: boolean | Function) => boolean | Function;
    handleSizeChange: (value: number) => void;
    handleCurrentChange: (value: number) => void;
    expandComputed: (scope: any, item: any, key: any) => any;
    handleDialogClose: () => void;
    IsUploadEditor: ComputedRef<string[]>;
    watchGetData: (row: {
        url: any;
        name: any;
        data: any;
        label: string | number | (string | number)[];
        value: string | number;
        key: any;
    }) => void;
    queryRecord: () => void;
    responseData: (Data: any, reqDataSource: any) => void;
    refresh: () => void;
    resetForm: (formEl: any) => void;
    addRecord: () => void;
    editRecord: (row: any) => void;
    handleSubmit: (formEl: any) => Promise<void>;
    handleAdd: (value: any) => void;
    handleEdit: (value: any) => MessageHandler | undefined;
    delFlag: (row: any) => void;
    deleteRecord: (row: any) => void;
    deleteMulRecord: () => void;
    CrudState: {
        ElementArrs: {
            filter: columnsType;
            editor: columnsType;
            column: columnsType;
        };
        tableData: any;
        multipleSelection: never[];
        searchModel: any;
        searchFormValue: any;
        editModel: any;
        editFormValue: any;
        uploadFiles: never[];
        tableLoading: boolean;
        Pagination: {
            current: any;
            pageSize: any;
            total: any;
        };
        Mode: string;
        queryRecord: () => void;
        refresh: () => void;
        resetForm: (formEl: any) => void;
        addRecord: () => void;
        editRecord: (row: any) => void;
        handleSubmit: (formEl: any) => Promise<void>;
        handleAdd: (value: any) => void;
        handleEdit: (value: any) => MessageHandler | undefined;
        delFlag: (row: any) => void;
        deleteRecord: (row: any) => void;
        deleteMulRecord: () => void;
    };
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, ("update:modelValue" | "cell-click" | "row-contextmenu")[], "update:modelValue" | "cell-click" | "row-contextmenu", VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    url: {
        type: StringConstructor;
        required: true;
    };
    source: {
        type: null;
        required: true;
    };
    rowKey: {
        type: StringConstructor;
        required: false;
    };
    rowKeys: {
        type: ArrayConstructor;
        required: false;
    };
    keyName: {
        type: StringConstructor;
        required: false;
    };
    AddInitID: {
        type: ArrayConstructor;
        required: false;
    };
    watchData: {
        type: ArrayConstructor;
        required: false;
    };
    hooks: {
        type: null;
        required: false;
    };
    wrapperStyle: {
        type: ObjectConstructor;
        required: false;
    };
    tableHeight: {
        type: NumberConstructor;
        required: false;
    };
    tableAttributes: {
        type: ObjectConstructor;
        required: false;
    };
    editFooterButton: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    queryAfterMount: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    permission: {
        type: ArrayConstructor;
        required: false;
        default: () => any;
    };
    IssearchForm: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    openIndex: {
        type: BooleanConstructor;
        required: false;
    };
    openMultipleSelection: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    expand: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    expandColumn: {
        type: NumberConstructor;
        required: false;
        default: () => any;
    };
    dialogWidth: {
        type: NumberConstructor;
        required: false;
        default: () => any;
    };
    fullscreen: {
        type: BooleanConstructor;
        required: false;
    };
    closeOnPressEscape: {
        type: BooleanConstructor;
        required: false;
    };
    destroyOnClosModal: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
    PaginationLayout: {
        type: StringConstructor;
        required: false;
        default: () => any;
    };
    hideOnSinglePage: {
        type: BooleanConstructor;
        required: false;
        default: () => any;
    };
}>> & {
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
    "onCell-click"?: ((...args: any[]) => any) | undefined;
    "onRow-contextmenu"?: ((...args: any[]) => any) | undefined;
}, {
    editFooterButton: boolean;
    queryAfterMount: boolean;
    permission: unknown[];
    IssearchForm: boolean;
    openIndex: boolean;
    openMultipleSelection: boolean;
    expand: boolean;
    expandColumn: number;
    dialogWidth: number;
    fullscreen: boolean;
    closeOnPressEscape: boolean;
    destroyOnClosModal: boolean;
    PaginationLayout: string;
    hideOnSinglePage: boolean;
}>;
export default _sfc_main;
